/*******************************************************************************
 *	@file			DLGraph.cpp
 *	@brief			DirectX Library
 *
 *	@date			21-Apr-2010(Wed)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DLGraph.h"

// O[oϐ---------------------------------------------------------

// ֐vg^Cv錾---------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

/*******************************************************************************
 *	@fn				CDLGraph::CDLGraph( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLGraph::CDLGraph( void )
	: m_lpD3D( NULL )
	, m_lpD3DDev( NULL )

	, m_hWnd()
	, m_D3DPP()
	, m_D3DDM()
	, m_D3DVP()
{
}

/*******************************************************************************
 *	@fn				CDLGraph::~CDLGraph( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLGraph::~CDLGraph( void )
{
}

/*******************************************************************************
 *	@fn				int CDLGraph::Init( const SDLParam& SDL )
 *	@param[in]		SDL							DL\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CDLGraph::Init( const SDLParam& SDL )
{
	m_hWnd = SDL.m_hWnd;
	HRESULT hr = D3D_OK;

	// IDirect3D9 C^[tFCX̎擾
	// http://msdn.microsoft.com/ja-jp/library/cc324303.aspx
	m_lpD3D = ::Direct3DCreate9( D3D_SDK_VERSION );
	if( m_lpD3D == NULL )
	{
		DXTRACE_MSG( "Direct3DCreate9()" );
		return FALSE;
	}

	// foCX\̂̏
	::ZeroMemory( &m_D3DPP, sizeof( D3DPRESENT_PARAMETERS ) );

	// ݂̉ʃ[h擾܂
	// http://msdn.microsoft.com/ja-jp/library/cc324298.aspx
	hr = m_lpD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &m_D3DDM );
	if( FAILED( hr ) )
	{
		DXTRACE_ERR( "GetAdapterDisplayMode()", hr );
		return FALSE;
	}

	// foCX\̂̐ݒ
	// http://msdn.microsoft.com/ja-jp/library/cc323931.aspx
	m_D3DPP.Windowed	= SDL.m_bMode;
	m_D3DPP.SwapEffect	= D3DSWAPEFFECT_DISCARD;
	m_D3DPP.BackBufferFormat	= m_D3DDM.Format;
	m_D3DPP.BackBufferWidth		= SDL.m_nWidth;
	m_D3DPP.BackBufferHeight	= SDL.m_nHeight;
	m_D3DPP.BackBufferCount		= 1;

	// IDirect3Device9 C^[tFCX̎擾
	// http://msdn.microsoft.com/ja-jp/library/cc324295.aspx
	// HAL + HARDWARE
	hr = m_lpD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, m_hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DPP, &m_lpD3DDev );
	if( FAILED( hr ) )
	{
		DXTRACE_MSG( "CreateDevice()" );
		// HAL + SOFTWARE
		hr = m_lpD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, m_hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &m_D3DPP, &m_lpD3DDev );
		if( FAILED( hr ) )
		{
			// REF + SOFTWARE ͎gpȂ
			DXTRACE_ERR( "CreateDevice()", hr );
			return FALSE;
		}
	}

	// r[|[g̐ݒ
	// http://msdn.microsoft.com/ja-jp/library/cc323943.aspx
	m_D3DVP.X		= 0;
	m_D3DVP.Y		= 0;
	m_D3DVP.Width	= SDL.m_nWidth;
	m_D3DVP.Height	= SDL.m_nHeight;
	m_D3DVP.MinZ	= 0.0f;
	m_D3DVP.MaxZ	= 1.0f;
	hr = m_lpD3DDev->SetViewport( &m_D3DVP );
	if( FAILED( hr ) )
	{
		DXTRACE_ERR( "SetViewport()", hr );
		return FALSE;
	}

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLGraph::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 ******************************************************************************/
int CDLGraph::End( void )
{
	// IDirect3Device9 C^[tFCX̉
	_RELEASE( m_lpD3DDev );
	// IDirect3D9 C^[tFCX̉
	_RELEASE( m_lpD3D );

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLGraph::Update( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			ʍXV
 ******************************************************************************/
int CDLGraph::Update( void )
{
	HRESULT hr = D3D_OK;

	// ʂ̃NA
	hr = m_lpD3DDev->Clear( 0,
							NULL,
							D3DCLEAR_TARGET,
							D3DCOLOR_ARGB( 0x00, 0x00, 0x00, 0x00 ),
							1.0f,
							0 );
	if( FAILED( hr ) )
	{
		DXTRACE_ERR( "Clear()", hr );
		return FALSE;
	}

	// ʂ̕`Jn
	hr = m_lpD3DDev->BeginScene();
	if( SUCCEEDED( hr ) )
	{
		// ʂ̕`


		// ʂ̕`I
		m_lpD3DDev->EndScene();
	}

	// ʂ̕\
	hr = m_lpD3DDev->Present( NULL, NULL, NULL, NULL );

	return TRUE;
}

}	// namespace	DL
